Imports System.Drawing.Drawing2D

Public Class Form1
    ' Der qualifiziertere Teil des Quellcodes wurde mir freundlicherweise
    ' von GPM zu Verfgung gestellt :-)

    Dim bild As New System.Drawing.Bitmap(Application.StartupPath & "\" & Form2.Text & ".jpg")
    Dim bmp As New System.Drawing.Bitmap(Application.StartupPath & "\" & Form2.Text & ".jpg")
    Dim g As Graphics = Graphics.FromImage(bmp)
    Dim bl As New List(Of Double)                        ' die Bilderliste
    Dim b1 As Int32 = -1                                 ' -1 oder 1.Bild
    Dim z As Int32 = CInt(Form2.ComboBox2.Text)          ' Anzahl der Teilbilder einer Reihe(2,3,4,5,6,8,10)
    Dim tb As Int32                                      ' Anzahl der Teilbilder
    Dim tbg As Int32                                     ' Teilbildgre In Pixel

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        PictureBox1.Image = bmp

        ' die Teilbilder mischen
        tb = z * z
        tbg = 480 \ z
        Dim Rnd As New Random                            ' die Positionen per Zufall bestimmen
        Dim zahl As Int32
        bl.Clear()
        Do
            zahl = Rnd.Next(0, tb)                       ' eine Zahl zwischen 0 und tb
            If Not bl.Contains(zahl) Then bl.Add(zahl) '   wenn noch nicht vorhanden, dann einfgen
        Loop While bl.Count < tb                         ' bis 16 Zahlen In der Liste sind
        anzeige()                                        ' und nun das Puzzle anzeigen
    End Sub

    ' Hintergrund-Farbverlauf erstellen
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        ' Gre der Form
        Dim oRect As New Rectangle(0, 0, Me.Width, Me.Height)

        ' Neues Brush-Objekt mit den gewnschten Farben und 
        ' Farbverlauf-Richtung erstellen
        Dim oBrush As New LinearGradientBrush(oRect, Color.DarkSlateBlue, Color.DarkSeaGreen, _
          LinearGradientMode.ForwardDiagonal)

        ' Hintergrund-Farbverlauf anzeigen
        Dim g As Graphics = e.Graphics
        g.FillRectangle(oBrush, oRect)

        Dim fnt As New Font("Serifa BT", 12)
        Dim text As String = "Zwei angeklickte Teilbilder wechseln den Platz"
        Dim offset As Integer = 2

        g.TranslateTransform(-offset, 25)

        ' Anhebung zeichnen
        g.DrawString(text, fnt, Brushes.DarkRed, 125, -10)

        ' Normalbereich zeichnen
        g.TranslateTransform(-offset, -offset)
        g.DrawString(text, fnt, Brushes.Yellow, 125, -10)
    End Sub

    Private Sub anzeige()
        Dim h, v, x, y As Int32

        For i As Int32 = 0 To tb - 1
            y = i \ z                                   ' x+y sind die Anzeigekoordinaten
            x = i - y * z
            v = Convert.ToInt32(CLng(bl(i)) \ z)                               ' h+v ergeben das Teilbild (tbg x tbg)
            h = Convert.ToInt32(bl(i) - v * z)
            g.DrawImage(bild, x * tbg, y * tbg, New Rectangle(h * tbg, v * tbg, tbg, tbg), GraphicsUnit.Pixel)

        Next
        For x = 0 To 480 Step tbg

            g.DrawLine(Pens.Black, x, 0, x, 480)         ' senkrechte schwarze Linien
            g.DrawLine(Pens.Black, 0, x, 480, x)         ' wagerechte schwarze Linien
        Next
        PictureBox1.Refresh()
    End Sub

    Private Sub PictureBox1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseDown

        Dim nr, sp As Int32
        If e.Y < 480 AndAlso e.X < 480 Then              ' ohne Randlinie
            Console.Beep(800, 20)                        ' akustisches Signal
            nr = z * (e.Y \ tbg) + e.X \ tbg             ' Mausposition wird Bildnummer
            If b1 = -1 Then                              ' wenn noch kein 1.Bild ausgewhlt wurde
                b1 = nr                                  ' die Nummer des Bildes In b1 speichern
                PictureBox1.Cursor = Cursors.Hand        ' das Cursorbild auf Hand setzen
                Exit Sub                                 ' fertig
            End If                                       ' wenn schon ein 1.Bild ausgewhlt wurde
            sp = Convert.ToInt32(bl(b1))                                  ' dieses Bild zwischenspeichern
            bl(b1) = bl(nr)                              ' nun die beiden Bilder tauschen
            bl(nr) = sp
            b1 = -1                                      ' Reset Bildnummer
            PictureBox1.Cursor = Cursors.Default         ' normaler Cursor
            For i As Int32 = 0 To tb - 1                 ' nun prfen ob das Bild schon fertig ist
                If i <> bl(i) Then                       ' wenn die Werte nicht gleich sind 
                    anzeige()                            ' das Puzzlebild anzeigen
                    Exit Sub                             ' und bildvergleich verlassen 
                End If
            Next
            PictureBox1.Image = bild                     ' das Puzzle ist gelst
        End If
    End Sub

End Class
